"use strict";
(self["webpackChunksentinll"] = self["webpackChunksentinll"] || []).push([[236],{

/***/ 77680:
/*!*******************************************************!*\
  !*** ./src/app/engineering-center/Enum/DeviceType.ts ***!
  \*******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   EnumDeviceType: () => (/* binding */ EnumDeviceType)
/* harmony export */ });
const EnumDeviceType = {
  BUBLL_DEVICE: "2",
  SENTINLL_DEVICE: "1"
};

/***/ }),

/***/ 28971:
/*!*****************************************************!*\
  !*** ./src/app/et/et-enum/aggregation-enum.enum.ts ***!
  \*****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   AggregationEnum: () => (/* binding */ AggregationEnum)
/* harmony export */ });
var AggregationEnum = /*#__PURE__*/function (AggregationEnum) {
  AggregationEnum[AggregationEnum["VALUE"] = 1] = "VALUE";
  AggregationEnum[AggregationEnum["PERCENTAGE"] = 2] = "PERCENTAGE";
  AggregationEnum[AggregationEnum["DELAY_TIME"] = 3] = "DELAY_TIME";
  AggregationEnum[AggregationEnum["CHANGEVALUE"] = 4] = "CHANGEVALUE";
  AggregationEnum[AggregationEnum["ANALOG_CHANGE_VALUE"] = 5] = "ANALOG_CHANGE_VALUE";
  return AggregationEnum;
}(AggregationEnum || {});

/***/ }),

/***/ 65649:
/*!***********************************************************!*\
  !*** ./src/app/et/et-enum/aggregation-type-label.enum.ts ***!
  \***********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   AggregationTypeLabel: () => (/* binding */ AggregationTypeLabel)
/* harmony export */ });
var AggregationTypeLabel = /*#__PURE__*/function (AggregationTypeLabel) {
  AggregationTypeLabel["VALUE"] = "Value";
  AggregationTypeLabel["PERCENTAGE"] = "Percentage";
  AggregationTypeLabel["DELAY_TIME"] = "Delay Time";
  AggregationTypeLabel["CHANGEVALUE"] = "Binary Change Value";
  AggregationTypeLabel["ANALOG_CHANGE_VALUE"] = "Analog Change Value";
  AggregationTypeLabel["PLUS_PERCENTAGE"] = "Plus Percentage";
  AggregationTypeLabel["MINUS_PERCENTAGE"] = "Minus Percentage";
  AggregationTypeLabel["SEQUENCE_NUMBER"] = "Sequence Number";
  AggregationTypeLabel["OPERATOR_TYPE"] = "Operator";
  AggregationTypeLabel["AGGREGATION_TYPE"] = "Aggregation Type";
  AggregationTypeLabel["CHANGE_VALUE"] = "Change Value";
  AggregationTypeLabel["MATCH_VALUE"] = "Match Value";
  AggregationTypeLabel[AggregationTypeLabel["PRIORITYONE"] = 1] = "PRIORITYONE";
  AggregationTypeLabel[AggregationTypeLabel["PRIORITYTWO"] = 2] = "PRIORITYTWO";
  return AggregationTypeLabel;
}(AggregationTypeLabel || {});

/***/ }),

/***/ 90550:
/*!************************************************!*\
  !*** ./src/app/et/et-enum/device-type.enum.ts ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   DeviceType: () => (/* binding */ DeviceType)
/* harmony export */ });
var DeviceType = /*#__PURE__*/function (DeviceType) {
  DeviceType["SENTINLL_DEVICE"] = "1";
  DeviceType["BUBLL_DEVICE"] = "2";
  DeviceType["BACNET_DEVICE"] = "3";
  DeviceType["TREND_DEVICE"] = "4";
  DeviceType["EXTENDED_DEVICE"] = "5";
  return DeviceType;
}(DeviceType || {});

/***/ }),

/***/ 16062:
/*!********************************************!*\
  !*** ./src/app/shared/Models/Container.ts ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Container: () => (/* binding */ Container),
/* harmony export */   SiteDetails: () => (/* binding */ SiteDetails)
/* harmony export */ });
class Container {
  constructor() {
    this.sites = new Array();
    this.aggregations = [];
    this.childContainers = [];
  }
}
class SiteDetails {}

/***/ }),

/***/ 73595:
/*!*********************************************************!*\
  !*** ./src/app/shared/services/et/container.service.ts ***!
  \*********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ContainerService: () => (/* binding */ ContainerService)
/* harmony export */ });
/* harmony import */ var _utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../../utils/SentinllURLS */ 27425);
/* harmony import */ var _api_service__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../api.service */ 37554);
/* harmony import */ var _localData_containerType_json__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../../localData/containerType.json */ 85372);
/* harmony import */ var _enums_session_storage_keys_enum__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../../enums/session-storage-keys.enum */ 7193);
/* harmony import */ var _angular_core__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @angular/core */ 37580);






let ContainerService = /*#__PURE__*/(() => {
  class ContainerService {
    constructor(apiService) {
      this.apiService = apiService;
    }
    /**
     * This function is used to create category.
     * @param category
     * @param config
     * */
    createContainer(category, config = {
      errorHandlerCallback: null
    }) {
      return this.apiService.post(_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.CREATE_CONTAINER, category, config);
    }
    /**
     * This function is used to update category.
     * @param category
     * @param config
     */
    updateContainer(category, config = {
      errorHandlerCallback: null
    }) {
      return this.apiService.put(_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.UPDATE_CONTAINER, category, config);
    }
    /**
     * This function is used to get categories by companyId
     * @param companyId
     * @param config
     * */
    getContainersByCompanyId(companyId, config = {
      errorHandlerCallback: null
    }) {
      return this.apiService.get(`${_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.GET_CONTAINER}${companyId}/getContainersByCompanyId`, config);
    }
    /**
     * This function is used to get sub categories by categoryId
     * @param categoryId
     * @param config
     * */
    getSubCategoriesByCategoryId(categoryId, config = {
      errorHandlerCallback: null
    }) {
      return this.apiService.get(`${_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.GET_CONTAINER}${categoryId}/getSubCategoriesByCategoryId`, config);
    }
    /**
     * This function is used to get all Categories by company id
     * @param companyId
     * @param queryParameter
     * @param config
     */
    getContainersListByCompanyId(companyId, queryParameter = null, config = {
      errorHandlerCallback: null
    }) {
      if (queryParameter) {
        return this.apiService.get(`${_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.GET_CONTAINER}${companyId}/getContainersByCompanyId?filter=${queryParameter}`, config);
      }
      return this.apiService.get(`${_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.GET_CONTAINER}${companyId}/getContainersByCompanyId`, config);
    }
    /**
     * This function is used to get Category Object using categoryId
     * @param categoryId
     * @param config
     */
    getContainersByContainerId(categoryId, config = {
      errorHandlerCallback: null
    }) {
      return this.apiService.get(`${_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.GET_CONTAINER}${categoryId}`, config);
    }
    /**
     * This function is used to delete category by Id
     * @param categoryId
     * @param config
     */
    deleteContainer(categoryId, config = {
      errorHandlerCallback: null
    }) {
      return this.apiService.delete(`${_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.DELETE_CONTAINER}${categoryId}/delete`, config);
    }
    /**
     * This function is used to read container json file
     */
    getContainers() {
      let container = [];
      container = _localData_containerType_json__WEBPACK_IMPORTED_MODULE_2__;
      return container;
    }
    /**
     * Used to set site id in session storage.
     * @param selectedSiteId
     * */
    setSelectedSiteId(selectedSiteId) {
      this.selectedSiteId = selectedSiteId;
      sessionStorage.setItem(_enums_session_storage_keys_enum__WEBPACK_IMPORTED_MODULE_3__.SessionStorageKeys.PREVIOUS_SELECTED_CONTAINER_SITE_ID, this.selectedSiteId);
    }
    /**
     * Used to set the site Id in serssion storage.
     * */
    getSelectedSiteId() {
      return sessionStorage.getItem(_enums_session_storage_keys_enum__WEBPACK_IMPORTED_MODULE_3__.SessionStorageKeys.PREVIOUS_SELECTED_CONTAINER_SITE_ID);
    }
    /**
     * This function is used to get Category Object using categoryId
     * @param categoryId
     * @param childContainerSiteId
     * @param config
     */
    getSiteContainerMapping(categoryId, childContainerSiteId = "", config = {
      errorHandlerCallback: null
    }) {
      if (childContainerSiteId) {
        return this.apiService.get(`${_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.GET_SITE_CONTAINER}${categoryId}/getSiteContainerMappingByContainerId?siteId=${childContainerSiteId}`, config);
      } else {
        return this.apiService.get(`${_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.GET_SITE_CONTAINER}${categoryId}/getSiteContainerMappingByContainerId`, config);
      }
    }
    /**
     * This function is used to get parent and sub containers by site id
     * @param siteId
     * @param offset
     * @param num
     * @param config
     */
    getSubContainersListBySiteId(siteId, offset, num, config = {
      errorHandlerCallback: null
    }) {
      return this.apiService.get(`${_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.GET_SITE_CONTAINER}${siteId}/getMappedSubcontainersBySiteId?offset=${offset}&num=${num}`, config);
    }
    /**
     * This function is used to get parent and sub containers by site id
     * @param siteId
     * @param config
     */
    getAllContainersListBySiteId(siteId, config = {
      errorHandlerCallback: null
    }) {
      return this.apiService.get(`${_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.GET_SITE_CONTAINER}${siteId}/getSiteContainerBySiteId`, config);
    }
    /**
    * function to get ET containers Aggregation by containerId
     * @param containerId
     * @param config
     */
    getContainerAggregationByContainerId(containerId, config = {
      errorHandlerCallback: null
    }) {
      return this.apiService.get(`${_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.GET_ET_CONTAINER_PREV_AGGREGATION}getAggregationsByContainerId/${containerId}`, config);
    }
    /**
     * This function is used to get categories by siteId.
     * @param siteId
     * @param config
     * */
    getContainersBySiteId(siteId, config = {
      errorHandlerCallback: null
    }) {
      return this.apiService.get(`${_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.GET_CONTAINER_BY_SITE}${siteId}/getSiteContainerBySiteId`, config);
    }
    /**
     * This function is used to update aggregation on container.
     * @param category
     * @param config
     * */
    updateDefalutAggregation(category, config = {
      errorHandlerCallback: null
    }) {
      return this.apiService.put(_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.UPDATE_CONTAINER, category, config);
    }
    /**
     * Use for get default container list
     * @param config
     * **/
    getDefaultContainers(config = {
      errorHandlerCallback: null
    }) {
      return this.apiService.get(_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.GET_DEFAULT_CONTAINER, config);
    }
    /**
     * This function is used to get superadmin containers
     * @param companyId
     * @param config
     */
    getSuperAdminContainersList(companyId, config = {
      errorHandlerCallback: null
    }) {
      return this.apiService.get(`${_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.GET_CONTAINER}${companyId}/default/getDefaultContainersByCompanyId`, config);
    }
    /**
     * Used to return the defaults container list.
     * @param config
     * */
    getDefaultContainerByUserId(config = {
      errorHandlerCallback: null
    }) {
      return this.apiService.get(_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.GET_USER_DEFAULT_CONTAINER, config);
    }
    /**
     * This function is used to update category.
     * @param category
     * @param config
     */
    updateContainerName(category, config = {
      errorHandlerCallback: null
    }) {
      return this.apiService.put(_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.UPDATE_CONTAINER_NAME, category, config);
    }
    /**
     * This function is used to update category.
     * @param category
     * @param config
     */
    renameContainerName(category, config = {
      errorHandlerCallback: null
    }) {
      return this.apiService.post(_utils_SentinllURLS__WEBPACK_IMPORTED_MODULE_0__.SentinllURLS.RENAME_CONTAINER_NAME, category, config);
    }
    static #_ = (() => this.ɵfac = function ContainerService_Factory(__ngFactoryType__) {
      return new (__ngFactoryType__ || ContainerService)(_angular_core__WEBPACK_IMPORTED_MODULE_4__["ɵɵinject"](_api_service__WEBPACK_IMPORTED_MODULE_1__.ApiService));
    })();
    static #_2 = (() => this.ɵprov = /*@__PURE__*/_angular_core__WEBPACK_IMPORTED_MODULE_4__["ɵɵdefineInjectable"]({
      token: ContainerService,
      factory: ContainerService.ɵfac,
      providedIn: "root"
    }))();
  }
  return ContainerService;
})();

/***/ }),

/***/ 1635:
/*!*******************************************!*\
  !*** ./src/app/shared/utils/ClientIds.ts ***!
  \*******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ClientIdConstants: () => (/* binding */ ClientIdConstants)
/* harmony export */ });
/* harmony import */ var _services_sharedServices_commonService_common_service__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../services/sharedServices/commonService/common.service */ 24184);
/* harmony import */ var _services_sharedServices_utilService_util_service__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../services/sharedServices/utilService/util.service */ 25648);


class ClientIdConstants {
  static #_ = (() => this.commonService = new _services_sharedServices_commonService_common_service__WEBPACK_IMPORTED_MODULE_0__.CommonService(new _services_sharedServices_utilService_util_service__WEBPACK_IMPORTED_MODULE_1__.UtilService(ClientIdConstants.modalService), null, null))();
  static #_2 = (() => this.userId = ClientIdConstants.commonService.getUserId())(); // get SeninllObjectClientID
  static getSO() {
    return new Promise(resolve => {
      setTimeout(() => {
        resolve(ClientIdConstants.userId + "_SO_" + new Date().getTime());
      }, 1); // hold for 1 millisecond to return unique id
    });
  }
  /*
   * Function use for generate unique containerClientId.
   */
  static getCT() {
    return new Promise(resolve => {
      setTimeout(() => {
        resolve("CON" + new Date().getTime() + Math.ceil(Math.random() * 10000).toString());
      }, 1); // hold for 1 millisecond to return unique id
    });
  }
  // Get sentinllDeviceClientID
  static getSD() {
    return new Date().getTime() + Math.ceil(Math.random() * 10000).toString();
  }
}

/***/ })

}]);
//# sourceMappingURL=236.js.map